package models

import (
	"code.gitea.io/gitea/modules/log"
	"code.gitea.io/gitea/modules/timeutil"
)

type RecommendOrg struct {
	ID          int64              `xorm:"pk autoincr"`
	Order       int64              `xorm:"INDEX NOT NULL unique"`
	OrgID       int64              `xorm:"INDEX NOT NULL unique"`
	CreatedUnix timeutil.TimeStamp `xorm:"created"`

	Org *User `xorm:"-"`
}

type RecommendOrgList []*RecommendOrg

func getRecommendOrgs(e Engine) (RecommendOrgList, error) {
	orgs := make(RecommendOrgList, 0, 10)
	err := e.Asc("order").
		Find(&orgs)
	return orgs, err
}

func GetRecommendOrgs() (RecommendOrgList, error) {
	return getRecommendOrgs(x)
}

func delRecommendOrgs(e Engine) error {
	sql := "delete from recommend_org"
	_, err := e.Exec(sql)
	return err
}

func UpdateRecommendOrgs(orgs RecommendOrgList) error {
	if err := delRecommendOrgs(x); err != nil {
		log.Error("delRecommendOrgs failed:%v", err.Error())
		return err
	}

	if _, err := x.Insert(&orgs); err != nil {
		log.Error("Insert failed:%v", err.Error())
		return err
	}

	return nil
}
